class player
 {
 	private:
 	 enum { N_WE=8 };
 	 enum { _COL=25, _ROW=7, _XPIX=46, _YPIX=46 };
 	 int plat_layer;
 	 int max_we;
 	 int pos_x,pos_y,glob_x,glob_y,scroll_x,scroll_y,jump_y,_X,_Y,restart_x,restart_y;
 	 int scroll_center_x,scroll_center_y,max_x,max_y;
 	 int *stage,*lives,* score;
 	 int armo_x[6],armo_y[6];
 	 int shild_x[2],shild_y[2];
 	 int plat_y,plat_stair,plat_wall;
 	 int dx,dy;
 	 int act_frame,dress,armour_count,shild_count,gold_frame,bigfrm;
 	 bonus *bshild;
 	 bool side,direction; // posizione speculare e direzione di moto 0 = destra, 1 = sinistra
 	 bool stop,move,gold,jump_up,jump_down,jump_hit_up,jump_hit_down,down,climb,fire1,fire2,fire_down,fire_up,fall,turn,dead,restart,ready_go;
 	 bool hittable,hitted,armour_down,armour_side,shild_down,shild_side;
 	 bool shild,powerup;
 	 bool key_taked;
   timer *ti[6];
   weapon *weap[N_WE];
 	 SAMPLE *sound[10];
 	 BITMAP *frame[_COL*_ROW+1];
 	 BITMAP *frame_col[2][_COL*_ROW+1];
 	 BITMAP *out;
 	 map *plat_map;
 	 map *hight_map;
 	 map *back_map;
 	 osd *_osd;

   void addGlobY(int);
   void addGlobX(int);
 	 void loadSpriteFrames(char *);
 	 void setOutBitmap(BITMAP *);
 	 void shootWeapon();
 	 void resetArmour();
 	 void resetShild();
 	 void moveArmour();
 	 void moveShild();
 	
 	public:
 	 player(char *,int,int,BITMAP *);
 	 ~player();
 	 void drawSprite();
 	 void drawShild(bool);
 	 void drawCloak();
 	 void timeSprite();
 	 void platformSprite();
 	 void moveSprite();
 	 void animSprite();
 	 void setOSD(osd *);
 	 void setPlatformMap(map *p);
 	 void setHightMap(map *p);
 	 void setBackgroundMap(map *p);
 	 void takeBonus(int,int extra=0);
 	 void loadSample(char *,int);
 	 void resetPlayer(int,int,bool first=false);
 	 BITMAP *getActFrameColP(bool sh=false);
 	 int getActPlatLayer();
 	 weapon *getWeapon(int);
 	 void setScrollCenterX(int);
 	 void setScrollCenterY(int);
 	 void setStageP(int *);
 	 void setLivesP(int *);
 	 void setScoreP(int *);
 	 void setShildP(bonus *);
 	 void setShildHit(bool);
 	 void setShild(bool);
 	 void setDress(int);
 	 bool getReadyGo();
 	 bool getShild();
 	 bool getPowerUp();
 	 bool getKeyTaked();
 	 int getDress();
 	 int getPlatYPos();
 	 int getActWeapon();
 	 int getPosX();
 	 int getPosY();
 	 int getNWeapon();
 	 int getX();
 	 int getY();
 	 int getGlobX();
 	 int getGlobY();
 	 int *getScrollXP();
 	 int *getScrollYP();
 	 int *getGlobXP();
   int *getGlobYP();
 	 void setHitted(bool);
 	 bool isHittable();
 	 bool isGold();
 	 void calcMax();
 	 void debug();
 };

player::player(char *filename, int rsx, int rsy, BITMAP *out)
 {
 	loadSpriteFrames(filename);
 	setOutBitmap(out);
 	powerup=0;
 	resetPlayer(rsx,rsy,true);
 	// Weapon
 	weap[0]=new weapon("data/obj/player/weapon.bmp",out);
 	weap[0]->loadSample("data/sound/fx/hard.wav",0);
 	max_we=2; // Numero di armi usate su un totale di N_WE sprite
 	for(int i=1;i<N_WE;i++)
 	 {
 	  weap[i]=new weapon("",out,i,weap[0]);
 	  weap[i]->assignSample(0,weap[0]);
 	  weap[i]->setIndex(i%2);
 	 }
 	for(int i=0;i<N_WE;i++)
 	 {
 	 	weap[i]->setPlayerXP(&_X);
 	  weap[i]->setPlayerYP(&_Y);
 	 }
 	ti[0]=new timer(2);   // Move time
 	ti[1]=new timer(2);   // Fire time
 	ti[2]=new timer(3);   // Flashing time
 	ti[3]=new timer(130); // Invisible time
 	ti[4]=new timer(4);   // Dead/Gold time
 	ti[5]=new timer(16);  // Gold time
 }

player::~player()
 {
 	for(int i=0;i<N_WE;i++) delete(weap[i]);
 	for(int i=0;i<6;i++)    free(ti[i]);
  for(int i=0;i<7;i++)    destroy_sample(sound[i]);
 	for(int i=0;i<_ROW*_COL;i++) destroy_bitmap(frame[i]);
 	for(int i=0;i<_ROW*_COL;i++) { destroy_bitmap(frame_col[0][i]); destroy_bitmap(frame_col[1][i]); }
 	destroy_bitmap(frame[bigfrm]);
 	destroy_bitmap(frame_col[0][bigfrm]);
 	destroy_bitmap(frame_col[1][bigfrm]);
 }

void player::loadSpriteFrames(char *filename)
 {
 	BITMAP *aux;

  aux=load_bmp(filename,NULL);
  for(int i=0;i<_ROW;i++)
   for(int j=0;j<_COL;j++)
    {
     //frame[j+_COL*i]=create_sub_bitmap(aux,46*j+j,46*i+i,46,46);
     frame[j+_COL*i]=create_bitmap(_XPIX,_YPIX);
     blit(aux,frame[j+_COL*i],_XPIX*j+j,_YPIX*i+i,0,0,frame[j+_COL*i]->w,frame[j+_COL*i]->h);
     frame_col[0][j+_COL*i]=create_bitmap_ex(8,_XPIX,_YPIX);
     frame_col[1][j+_COL*i]=create_bitmap_ex(8,_XPIX,_YPIX);
     clear_to_color(frame_col[0][j+_COL*i],0);
     clear_to_color(frame_col[1][j+_COL*i],0);
     for(int h=0;h<frame[j+_COL*i]->h;h++)
      for(int w=0;w<frame[j+_COL*i]->w*4;w+=4)
       if(makecol32(frame[j+_COL*i]->line[h][w+2],
                    frame[j+_COL*i]->line[h][w+1],
                    frame[j+_COL*i]->line[h][w])!=16711935)
                     {
                      frame_col[0][j+_COL*i]->line[h][w>>2]=1;
                      frame_col[1][j+_COL*i]->line[h][(((frame[j+_COL*i]->w-1)*4)>>2)-(w>>2)]=1;
                     }             
    }
  // Frame gold grande
  bigfrm=175;
  frame[bigfrm]=create_bitmap(104,59);
  blit(aux,frame[bigfrm],0,541,0,0,frame[bigfrm]->w,frame[bigfrm]->h);
  frame_col[0][bigfrm]=create_bitmap_ex(8,104,59);
  frame_col[1][bigfrm]=create_bitmap_ex(8,104,59);
  clear_to_color(frame_col[0][bigfrm],0);
  clear_to_color(frame_col[1][bigfrm],0);
  for(int h=0;h<frame[bigfrm]->h;h++)
   for(int w=0;w<frame[bigfrm]->w*4;w+=4)
    if(makecol32(frame[bigfrm]->line[h][w+2],
                 frame[bigfrm]->line[h][w+1],
                 frame[bigfrm]->line[h][w])!=16711935)
                  {
                   frame_col[0][bigfrm]->line[h][w>>2]=1;
                   frame_col[1][bigfrm]->line[h][(((frame[bigfrm]->w-1)*4)>>2)-(w>>2)]=1;
                  }

  destroy_bitmap(aux);
 }

void player::loadSample(char *filename, int n)
 {
 	sound[n]=load_sample(filename);
 }

void player::resetPlayer(int rx,int ry,bool first)
 {
 	restart_x=rx; restart_y=ry;
 	act_frame=0; dress=0; // 0=Armour, 1=Naked 2=Magic armour 3=Dead
 	gold=0; stop=1; move=0; jump_up=0; jump_down=0; down=0; climb=0; fire1=0; fire2=0; fire_down=0; fire_up=0; fall=0; turn=0; dead=0; restart=0; ready_go=0;
 	hittable=1; hitted=0; armour_down=0; armour_count=0; shild_down=0; shild_count=0; jump_hit_up=0; jump_hit_down=0;
 	side=0; direction=0;
 	dx=0; dy=0; jump_y=0;
 	shild=0; shild_side=0; armour_side=0; key_taked=0;
 	scroll_center_x=192; scroll_center_y=112;
 	scroll_x=0; scroll_y=0;
 	pos_x=glob_x=restart_x; pos_y=glob_y=restart_y; plat_y=restart_y;
 	if(!first) { platformSprite(); drawSprite(); }
 }

void player::setOutBitmap(BITMAP *bmp) { out=bmp; }

void player::timeSprite()
 {
 	for(int i=0;i<6;i++) ti[i]->time();
 }

void player::takeBonus(int bonus, int extra)
 {
 	if(bonus==1) { if(dress==2) dress=2; else dress=0; play_sample(sound[4],120,150,1000,0); hittable=1; } // Normal armour
 	if(bonus==2) { if(dress==0 || dress==2) { gold=1; ti[5]->reset(); ti[4]->reset(); gold_frame=87; act_frame=41; } else dress=0; play_sample(sound[4],120,150,1000,0); hittable=1; } // Gold armour
 	if(bonus==3) { for(int i=0;i<N_WE;i++) max_we=weap[i]->setActWeapon(extra,powerup); _osd->setActWeapon(extra,powerup); } // Change Weapon
 	if(bonus==4) { play_sample(sound[6],120,150,1000,0); if(extra==0) *score+=200; if(extra==1) *score+=500; if(extra==2) *score+=800; if(extra==3) *score+=1000; if(extra==3) *score+=100; } // Bonus punti
 	if(bonus==5) shild=1; // Scudo
 	if(bonus==7) { powerup=1; for(int i=0;i<N_WE;i++) max_we=weap[i]->setActWeapon(getActWeapon(),powerup); _osd->setActWeapon(getActWeapon(),powerup); } // Powerup armi
 	if(bonus==10) { (*stage)++; glob_x=0; glob_y=0; restart=1; key_taked=1; } // Key (next level)
 }

void player::shootWeapon()
 {
 	// Manca magic power (TODO)
 	int n=-1;
 	play_sample(sound[0],120,150,1000,0);
 	if(!weap[0]->isTwo()) // One bullet a time
 	 {
 	  for(int i=0;i<max_we;i++) if(!weap[i]->isFired()) { n=i; break; }	
 	  if(n!=-1)
 	   {
 	 	  if(fire1 || fire2) // Normale o abbassato
  	   if(down)
  	    if(side) weap[n]->shoot(plat_map->getScrollX()+pos_x-4,plat_map->getScrollY()+pos_y+10,side,0,plat_layer,true,false,false,powerup);
  	    else     weap[n]->shoot(plat_map->getScrollX()+pos_x+4,plat_map->getScrollY()+pos_y+10,side,0,plat_layer,true,false,false,powerup);
       else 
        if(side) weap[n]->shoot(plat_map->getScrollX()+pos_x-4,plat_map->getScrollY()+pos_y-4,side,0,plat_layer,false,false,false,powerup);
        else     weap[n]->shoot(plat_map->getScrollX()+pos_x+4,plat_map->getScrollY()+pos_y-4,side,0,plat_layer,false,false,false,powerup);
 	 	  if(fire_up) // In alto
       weap[n]->shoot(plat_map->getScrollX()+pos_x,plat_map->getScrollY()+pos_y-4,side,1,plat_layer,false,true,false,powerup);
 	 	  if(fire_down) // In basso
       weap[n]->shoot(plat_map->getScrollX()+pos_x,plat_map->getScrollY()+pos_y+6,side,2,plat_layer,false,false,true,powerup);
     }
   }
  else // two bullet a time
   {
    for(int i=0;i<max_we;i+=2) if(!weap[i]->isFired() && !weap[i+1]->isFired()) { n=i; break; }
    if(n!=-1)
 	   {
 	 	  for(int j=0;j<2;j++)
 	 	   {
 	 	    if(fire1 || fire2) // Normale o abbassato
  	     if(down)
  	      if(side) weap[n]->shoot(plat_map->getScrollX()+pos_x-4,plat_map->getScrollY()+pos_y+10,side,0,plat_layer,true,false,false,powerup);
  	      else     weap[n]->shoot(plat_map->getScrollX()+pos_x+4,plat_map->getScrollY()+pos_y+10,side,0,plat_layer,true,false,false,powerup);
         else 
          if(side) weap[n]->shoot(plat_map->getScrollX()+pos_x-4,plat_map->getScrollY()+pos_y-4,side,0,plat_layer,false,false,false,powerup);
          else     weap[n]->shoot(plat_map->getScrollX()+pos_x+4,plat_map->getScrollY()+pos_y-4,side,0,plat_layer,false,false,false,powerup);
 	 	    if(fire_up) // In alto
         weap[n]->shoot(plat_map->getScrollX()+pos_x,plat_map->getScrollY()+pos_y-4,side,1,plat_layer,false,true,false,powerup);
 	 	    if(fire_down) // In basso
         weap[n]->shoot(plat_map->getScrollX()+pos_x,plat_map->getScrollY()+pos_y+6,side,2,plat_layer,false,false,true,powerup);
        n++;
       }
     }
   }
 }

void player::resetArmour()
 {
 	armour_side=side;
 	armour_down=1;
 	armour_count=0;
 	armo_x[0]=_X; armo_y[0]=_Y-10;
 	armo_x[1]=_X; armo_y[1]=_Y-10;
 	armo_x[2]=_X; armo_y[2]=_Y-5;
 	armo_x[3]=_X; armo_y[3]=_Y-5;
 	armo_x[4]=_X; armo_y[4]=_Y;
 	armo_x[5]=_X; armo_y[5]=_Y;
 }

void player::moveArmour()
 {
 	int ss,dd,gg;
 	
 	if(armour_side) ss=-1; else ss=1;
 	armour_count++; if(armour_count==85) armour_down=0;
 	gg=armour_count/5;
 	armo_x[0]-=ss*2; armo_y[0]-=2-gg;
 	armo_x[1]+=ss*2; armo_y[1]-=2-gg;
 	armo_x[2]-=ss*2; armo_y[2]-=1-gg;
 	armo_x[3]+=ss*2; armo_y[3]-=1-gg;
 	armo_x[4]-=ss*1; armo_y[4]-=0-gg;
 	armo_x[5]+=ss*1; armo_y[5]-=0-gg;
 }

void player::resetShild()
 {
 	shild_side=side;
 	shild_down=1;
 	shild_count=0;
 	shild_x[0]=_X; shild_y[0]=_Y-10;
 	shild_x[1]=_X; shild_y[1]=_Y;
 }

void player::moveShild()
 {
 	int ss,dd,gg;
 	
 	if(shild_side) ss=-1; else ss=1;
 	shild_count++; if(shild_count==85) shild_down=0;
 	gg=shild_count/5;
 	shild_x[0]-=ss*2; shild_y[0]-=2-gg;
 	shild_x[1]+=ss*1; shild_y[1]-=0-gg;
 }

void player::moveSprite()
 {
    /*if(key[KEY_UP])           { addGlobY(-4); }
    if(key[KEY_DOWN])         { addGlobY(4);  }
    if(key[KEY_LEFT])         { addGlobX(-4); }
    if(key[KEY_RIGHT])        { addGlobX(4);  }

return;*/
  if(gold) return;
 	if(restart) { if(ti[3]->isOn()) { if(!key_taked) (*lives)--; ready_go=1; } }
 	if(_Y>224 && !dead) { dead=1; dress=1; setHitted(true); }
 	if(dead) return; // Dead
 	if(jump_hit_up || jump_hit_down) return; // Hitted
 	if(climb) // Sulla scala
 	 {
    if(key[KEY_UP])           { addGlobY(-2); }
    if(key[KEY_DOWN])         { addGlobY(2);  }
    if(plat_stair==0)         { climb=0; }
    jump_up=0; jump_down=0; fire1=0; fire2=0; fire_down=0; fire_up=0;
    return;
 	 }
 	if(!jump_up && !jump_down && !fire1 && !fire2 && !fire_down && !fire_up && !climb) // Al suolo
 	 {
    if(!key[KEY_LEFT])        { move=0; stop=1; }
    if(!key[KEY_RIGHT])       { move=0; stop=1; }
    if(!key[KEY_DOWN])        { down=0; stop=1; }
    if(key[KEY_LEFT]  && !key[KEY_RIGHT]) { move=1; down=0; stop=0; if(!side) turn=1; direction=1; dx=-2; }
    if(key[KEY_RIGHT] && !key[KEY_LEFT])  { move=1; down=0; stop=0; if(side)  turn=1; direction=0; dx=2;  }
    if(key[KEY_LEFT]  &&  key[KEY_RIGHT]) { move=1; down=0; stop=0; if(side)  turn=1; direction=0; dx=2;  }
    if(key[KEY_UP] &&
       plat_stair==1)         { climb=1; stop=0; move=0; act_frame=18; glob_x=(glob_x/plat_map->getTileH()*plat_map->getTileH())+16; }
    if(key[KEY_DOWN])         { 
    	                         if(plat_stair==2) { climb=1; stop=0; move=0; act_frame=23; glob_x=(glob_x/plat_map->getTileH()*plat_map->getTileH())+16; }
    	                         else { down=1; move=0; stop=0; }
    	                        }
    if(key[KEY_ALT] && !fall) { jump_up=1; down=0; dy=-4; key[KEY_ALT]=0; jump_y=0; }
    if(key[KEY_LCONTROL])     {
    	                         move=0; stop=0;
    											     if(!down)       { fire1=1; fire2=0; fire_up=0; act_frame=10; }
    											     if(down)        { fire2=1; fire1=0; fire_up=0; act_frame=12; }
    											     if(key[KEY_UP]) { fire_up=1; fire1=0; fire2=0; act_frame=14; }
    	                         shootWeapon();
    	                         down=0;
    	                         key[KEY_LCONTROL]=0;
    	                        }
   }
  if((jump_up || jump_down) && !fire1 && !fire2 && !fire_down && !fire_up && !climb) // In volo
 	 {
    if(!key[KEY_LEFT])    { stop=1; }
    if(!key[KEY_RIGHT])   { stop=1; }
    if(!key[KEY_DOWN])    { down=0; stop=1; }
    if(key[KEY_LEFT]  && !key[KEY_RIGHT]) { if(!side) turn=1; }
    if(key[KEY_RIGHT] && !key[KEY_LEFT])  { if(side)  turn=1; }
    if(key[KEY_LEFT]  &&  key[KEY_RIGHT]) { if(side)  turn=1; }
    if(key[KEY_UP])       { }
    if(key[KEY_DOWN])     { }
    if(key[KEY_ALT])      { key[KEY_ALT]=0; }
    if(key[KEY_LCONTROL]) {
    											 stop=0;
    											 if(!down)         { fire1=1; fire2=0; fire_up=0; fire_down=0; act_frame=10; }
    											 if(down)          { fire2=1; fire1=0; fire_up=0; fire_down=0; act_frame=12; }
    											 if(key[KEY_UP])   { fire_up=1; fire1=0; fire2=0; fire_down=0; act_frame=14; }
    											 if(key[KEY_DOWN]) { fire_down=1; fire_up=0; fire1=0; fire2=0; act_frame=16; }
    	                     shootWeapon();
    	                     down=0;
    	                     key[KEY_LCONTROL]=0;
    	                    }
   }
 }

void player::animSprite()
 {
 	// Hit hard se "tocco" il terreno con le armi (solo per moto a sinistra e destra)
 	// Fare evantuali aggiustamente (se servono nelle varie stage) cambiando il valore di alt
 	int alt=999;

 	for(int i=0;i<N_WE;i++) if(weap[i]->isFired())
 	 {
 	 	if(weap[i]->getY()+scroll_y > plat_map->getActPlatLayerValue(weap[i]->getX()+scroll_x+20,weap[i]->getY()+scroll_y,weap[i]->getPlatLayer(),alt)+10 && weap[i]->getMoveDir()==0)
 	 	 weap[i]->hitHard();
 	 }

 	if(restart) return;
 	if(gold && !jump_down && !jump_up && !fall)
 	 {
 	 	dress=2;
 	 	if(act_frame<41) { act_frame=41; gold_frame=87; ti[4]->reset(); ti[5]->reset();}
 	 	if(ti[5]->isOn()) act_frame++; if(act_frame==44) { gold=0; act_frame=41; }
 	 	if(act_frame<=42) if(ti[4]->isOn()) { gold_frame++; if(gold_frame==89) gold_frame=87; }
 	 	if(act_frame>42)  if(ti[4]->isOn()) gold_frame++;
 	 	return;
 	 }
 	if(dead)
 	 {
 	  if(ti[4]->isOn() && act_frame>21) { act_frame--; ti[3]->reset(); }
 	 	if(ti[3]->isOn()) { ti[3]->reset(); act_frame=20; restart=1; }
 	 	return;
 	 }
 	if(hitted)
 	 {
 	 	stop=1; move=0; jump_up=0; jump_down=0; down=0; climb=0; fire1=0; fire2=0; fire_down=0; fire_up=0; fall=0; turn=0;
 	 	if(dress==1) dress=3;
 	 	if(dress==0) { dress=1; resetArmour(); }
 	 	if(dress==2) { dress=0; resetArmour(); }
 	 	hittable=0; hitted=0; direction=!side;
 	 	jump_hit_up=1; jump_hit_down=0; jump_y=0; dy=-4; dx=2; act_frame=24;
 	 	if(shild)
 	 	 { shild=0; bshild->setStartX(glob_x); bshild->setStartY(glob_y-38); bshild->resetObj(true,5); }
 	 	ti[3]->reset();
 	 }
 	if(!hittable) { if(ti[3]->isOn()) hittable=1; }
 	if(jump_hit_down)
 	 {
 	 	if(!plat_wall) if(side) addGlobX(dx); else addGlobX(-dx);
 	 	addGlobY(dy);
 	 	if(glob_y>=plat_y && dress==3) { dead=1; glob_y=plat_y; return; }
 	 	if(glob_y>=plat_y) { jump_hit_up=0; jump_hit_down=0; dy=0; glob_y=plat_y; play_sample(sound[1],120,150,1000,0); return; }
 	 	if(glob_y%5==0 && dy<7) dy++; // Gravit
 	 	if(dress==3) if(ti[4]->isOn() && act_frame>21) act_frame--; // Dead
 	 	return;
 	 }
 	if(jump_hit_up)
 	 {
 	 	if(!plat_wall) if(side) addGlobX(dx); else addGlobX(-dx);
 	 	jump_y++; if(jump_y==21) { jump_hit_up=0; jump_hit_down=1; dy=2; }
 	 	if(jump_y%5==0 && dy<7) dy++; // Gravit
 	 	addGlobY(dy);
 	 	return;
 	 }
 	if(turn) { if(plat_wall) dx=0; side=!side; turn=0; }
  if(stop) act_frame=0;
  if(climb)
   {
   	if(act_frame<18) act_frame=18;
   	if(key[KEY_UP] || key[KEY_DOWN]) if(ti[1]->isOn()) { act_frame++; if(act_frame>21) act_frame=18; }
   	jump_up=0; jump_down=0; fire1=0; fire2=0; fire_down=0; fire_up=0;
   	return;
   }
  if(move && !jump_up && !jump_down)
   {
   	if(!plat_wall) addGlobX(dx);
   	if(ti[0]->isOn()) { act_frame++; if(act_frame>6) act_frame=1; }
   }
 	if(jump_down)
 	 {
 	 	if(!fire1 && !fire2 && !fire_up && !fire_down)
 	 	 if(move && !fire1 && !fire2 && !fire_up && !fire_down) act_frame=8; else act_frame=9;
 	 	if(move) if(!plat_wall) addGlobX(dx);
 	 	if(glob_y>=plat_y) { jump_up=0; jump_down=0; move=0; dy=0; glob_y=plat_y; play_sample(sound[1],120,150,1000,0); return; }
 	 	if(glob_y%5==0 && dy<7) dy++; // Gravit
 	 }
 	if(jump_up)
 	 {
 	 	if(!fire1 && !fire2 && !fire_up && !fire_down)
 	 	 if(move) act_frame=8; else act_frame=9;
 	 	if(move) if(!plat_wall) addGlobX(dx);
 	 	jump_y++; if(jump_y==21) { jump_up=0; jump_down=1; dy=2; }
 	 	if(jump_y%5==0 && dy<7) dy++; // Gravit
 	 }
  if(down) act_frame=7;
  if(fall && !fire1 && !fire2 && !fire_up && !fire_down) { act_frame=0; }
  if(fire1)     { if(ti[1]->isOn()) { act_frame++; if(act_frame>11) { act_frame=11; fire1=0;     } } }
  if(fire2)     { if(ti[1]->isOn()) { act_frame++; if(act_frame>13) { act_frame=13; fire2=0;     } } }
  if(fire_up)   { if(ti[1]->isOn()) { act_frame++; if(act_frame>15) { act_frame=15; fire_up=0;   } } }
  if(fire_down) { if(ti[1]->isOn()) { act_frame++; if(act_frame>17) { act_frame=17; fire_down=0; } } }
  addGlobY(dy);
 }

void player::drawSprite()
 {
	pos_x=scroll_center_x;
 	if(glob_x<scroll_center_x) pos_x=glob_x; 
  if(scroll_x==max_x) pos_x=glob_x-scroll_x;
  pos_y=scroll_center_y;
 	if(glob_y<scroll_center_y) pos_y=glob_y;
  if(scroll_y==max_y) pos_y=glob_y-scroll_y;

 	if(glob_x<=scroll_center_x) scroll_x=0; else scroll_x=glob_x-scroll_center_x;
 	if(scroll_x>max_x) scroll_x=max_x;
 	if(glob_y<=scroll_center_y) scroll_y=0; else scroll_y=glob_y-scroll_center_y;
 	if(scroll_y>max_y) scroll_y=max_y;

  if(pos_x<22)  { pos_x=22;  glob_x=22; }
  if(pos_x>366) { pos_x=366; glob_x=max_x+366; }
  if(pos_y<0)   { pos_y=0;   glob_y=0; }
  if(pos_y>250) { pos_y=250; glob_y=max_y+250; }
  if(_Y<=-5) { glob_y+=2; } // Risolve bug uscita da schermo in alto e non c' scroll verticale
  
 	_X=pos_x-23; _Y=pos_y-12;
 	if(!hittable && dress!=3) // Flashing (manca ancora l'animazione completa del mantello)
   {
   	if(ti[2]->isOn() || act_frame==24)
   	  {
   	   drawShild(true);
   	   drawCloak();
       if(side) draw_sprite_h_flip(out,frame[act_frame+dress*25],_X,_Y);
       else     draw_sprite       (out,frame[act_frame+dress*25],_X,_Y);
       drawShild(false);
      }
   }
  else // Not flashing
   {
   	drawShild(true);
   	drawCloak();
   	if(side) draw_sprite_h_flip(out,frame[act_frame+dress*25],_X,_Y);
    else     draw_sprite       (out,frame[act_frame+dress*25],_X,_Y);
    drawShild(false);
   }

  // Armour hitted
  if(armour_down) moveArmour();
  if(armour_down && armour_side)
   {
    for(int i=0;i<6;i++)
     draw_sprite_h_flip(out,frame[i+6*dress+3*25],armo_x[i],armo_y[i]);
   }
  if(armour_down && !armour_side)
   {
    for(int i=0;i<6;i++)
     draw_sprite(out,frame[i+6*dress+3*25],armo_x[i],armo_y[i]);
   }

  // Shild hitted
  if(shild_down) moveShild();
  if(shild_down && shild_side)
   {
    for(int i=0;i<2;i++)
     draw_sprite_h_flip(out,frame[94],shild_x[i],shild_y[i]);
   }
  if(shild_down && !shild_side)
   {
    for(int i=0;i<2;i++)
     draw_sprite(out,frame[94],shild_x[i],shild_y[i]);
   }

  // Risolve bug animazione scudo
  if(act_frame==41 && shild) if(side) draw_sprite_h_flip(out,frame[7+5*25],_X,_Y);
                             else     draw_sprite       (out,frame[7+5*25],_X,_Y);
  // Gold armour taked
  if(gold)
   {
    if(shild)
      {
   	   if(side) { if(act_frame!=8) draw_sprite_h_flip(out,frame[7+5*25],_X,_Y); else draw_sprite_h_flip(out,frame[8+5*25],_X,_Y); }
       else     { if(act_frame!=8) draw_sprite       (out,frame[7+5*25],_X,_Y); else draw_sprite       (out,frame[8+5*25],_X,_Y); }
      }
   	if(gold_frame==91) draw_sprite(out,frame[bigfrm],_X-30,_Y-14);
   	else draw_sprite(out,frame[gold_frame],_X,_Y);
   }
  // Weapon
  // ... le ho messe fuori nel file game.h ( in player() e layer_s() )
 }

void player::drawShild(bool first)
 {
 	int shild_frame;
 	
 	shild_frame=act_frame+5*25;
 	if(first)
 	 {
    if(shild && !gold && dress!=3 && act_frame<41 && (act_frame!=0 || act_frame!=7 || act_frame!=9 || act_frame!=18 || act_frame!=19 || act_frame!=20 || act_frame!=21 || act_frame==22 || act_frame==23))
     {
   	  if(side) draw_sprite_h_flip(out,frame[shild_frame],_X,_Y);
      else     draw_sprite       (out,frame[shild_frame],_X,_Y);
     }
   }
  else
   {
    if(shild && !gold && dress!=3 && act_frame<41 && (act_frame==0 || act_frame==7 || act_frame==9 || act_frame==18 || act_frame==19 || act_frame==20 || act_frame==21 || act_frame==22 || act_frame==23))
     {
   	  if(side) draw_sprite_h_flip(out,frame[shild_frame],_X,_Y);
      else     draw_sprite       (out,frame[shild_frame],_X,_Y);
     } 	
   }
 }

void player::drawCloak()
 {
 	// Mantello
 	if(dress==2)
 	 {
 	 	if(act_frame>=1 && act_frame<=8)
   	 if(side) draw_sprite_h_flip(out,frame[act_frame+4*25],_X+46,_Y);
     else     draw_sprite       (out,frame[act_frame+4*25],_X-46,_Y);
    if(act_frame==9)
   	 if(side) draw_sprite_h_flip(out,frame[act_frame+4*25],_X,_Y+46);
     else     draw_sprite       (out,frame[act_frame+4*25],_X,_Y+46);    
 	 }
 }

void player::platformSprite()
 {//return;
 	// Get platform,walls and stairs
 	int plat_aux;

 	if(!jump_down && !jump_up && !climb && !jump_hit_down && !jump_hit_up)
 	{
 	 if(glob_y>plat_y) if(glob_y-plat_y<=8) glob_y=plat_y; 
 	 if(glob_y<plat_y) if(plat_y-glob_y<=8) glob_y=plat_y; 
 	 if(glob_y<plat_y) { fall=1; dy++; dx=0; } else { fall=0; dy=0; } 
 	}
 	plat_y=plat_map->getActPlatform(glob_x,glob_y);
 	plat_aux=plat_map->getActPlatformMobile(glob_x,glob_y);
 	if(abs(plat_aux-glob_y)<abs(plat_y-glob_y)) plat_y=plat_aux;
 	
 	plat_stair=plat_map->getActStair(glob_x,glob_y);
 	
 	plat_wall=plat_map->getActWall(direction,glob_x,glob_y);
 	if(!plat_wall) plat_wall=plat_map->getActWallMobile(direction,glob_x,glob_y);
 	
 	// Gestione collisioni armi terreno
 	if(glob_y==plat_y && !fall && !jump_down && !jump_up && !climb && !jump_hit_down && !jump_hit_up)
 	 {
 	  if(*stage==0) plat_layer=plat_map->getActPlatLayer(glob_x,glob_y,0,false);
 	  if(*stage==1) plat_layer=plat_map->getActPlatLayer(glob_x,glob_y,1,true);
 	  if(*stage==2) plat_layer=plat_map->getActPlatLayer(glob_x,glob_y,0,false);
 	  if(*stage==4) plat_layer=plat_map->getActPlatLayer(glob_x,glob_y,0,false);
 	 }
 }

BITMAP *player::getActFrameColP(bool sh)
 {
 	if(sh) return frame_col[side][act_frame+5*25];
  else return frame_col[side][act_frame+dress*25];
 }

int player::getActPlatLayer() { return plat_layer; }

weapon *player::getWeapon(int n) { return weap[n]; }

int player::getDress() { return dress; }

bool player::getShild() { return shild; }
                                           
bool player::getPowerUp() { return powerup; }
                                           
bool player::getReadyGo() { return ready_go; }

bool player::getKeyTaked() { return key_taked; }

int player::getPlatYPos() { return plat_y; }

void player::setStageP(int *p) { stage=p; }

void player::setLivesP(int *p) { lives=p; }

void player::setScoreP(int *p) { score=p; }

void player::setShildP(bonus *p) { bshild=p; }

void player::setScrollCenterX(int sc) { scroll_center_x=sc; }

void player::setScrollCenterY(int sc) { scroll_center_y=sc; }

int player::getActWeapon() { return weap[0]->getActWeapon(); }

int player::getPosX() { return pos_x; }

int player::getPosY() { return pos_y; }

int player::getNWeapon() { return N_WE; }

int player::getX() { return _X; }

int player::getY() { return _Y; }

int player::getGlobX() { return glob_x; }

int player::getGlobY() { return glob_y; }

int *player::getScrollXP() { return &scroll_x; }

int *player::getScrollYP() { return &scroll_y; }

int *player::getGlobXP() { return &glob_x; }

int *player::getGlobYP() { return &glob_y; }

void player::setHitted(bool fl)
 {
 	hitted=fl;
 	if(dress!=1) play_sample(sound[2],120,150,1000,0);
 	else play_sample(sound[3],120,150,1000,0);
 }

void player::setShildHit(bool b) {play_sample(sound[5],120,150,1000,0); resetShild(); shild=0; }

void player::setShild(bool b) { shild=b; }

void player::setDress(int d) { dress=d; }

bool player::isGold() { return gold; }

bool player::isHittable() { return hittable; }

void player::setOSD(osd *o) { _osd=o; }

void player::setPlatformMap(map *p) { plat_map=p; }

void player::setHightMap(map *p) { hight_map=p; }

void player::setBackgroundMap(map *p) { back_map=p; }

void player::addGlobX(int v) { glob_x+=v; }

void player::addGlobY(int v) { glob_y+=v; }

void player::calcMax()
 {
 	// Calcola i limiti entro i quali il giocatore pu muoversi
 	max_x=plat_map->getTotCol()*plat_map->getTileW()-plat_map->getNumCol()*plat_map->getTileW();
 	max_y=plat_map->getTotRow()*plat_map->getTileW()-plat_map->getNumRow()*plat_map->getTileW();
 }

void player::debug()
 {
 	putpixel(out,pos_x,pos_y,makecol32(255,0,255));
 	putpixel(out,pos_x+1,pos_y,makecol32(255,0,0));
 	putpixel(out,pos_x-1,pos_y,makecol32(255,0,0));
 	putpixel(out,pos_x,pos_y+1,makecol32(255,0,0));
 	putpixel(out,pos_x,pos_y-1,makecol32(255,0,0));
 	
 	for(int i=0;i<18;i++) putpixel(out,pos_x,pos_y-30+62-i,makecol32(255,0,0));
  putpixel(out,pos_x-2,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x+2,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x-1,pos_y-30+61,makecol32(255,0,0));
  putpixel(out,pos_x+1,pos_y-30+61,makecol32(255,0,0));
 }
